import 'dart:core';
import 'package:pioneer/pioneer.dart';

void main() async {
  JsonResponse handler_0(JsonRequest request) {
    return JsonResponse(data: {
      'handler': 'handler_0'
    });
  }

  JsonResponse handler_1(JsonRequest request, {int page}) {
    return JsonResponse(data: {
      'handler': 'handler_1 ${page}'
    });
  }

  JsonResponse handler_2(JsonRequest request, {int user, int page}) {
    return JsonResponse(data: {
      'handler': 'handler_2 ${user} ${page}'
    });
  }

  JsonResponse middleware_echo(JsonRequest request) {
    if (request.query['echo'] == null) {
      return null;
    }

    return JsonResponse(data: request.data, statusCode: 404);
  }
  
  Application application = new Application(
    middlewares: [
      middleware_echo
    ],
    routes: [
      new Route(Method.POST, r'articles', handler_0),
      new Route(Method.POST, r'articles/int:page', handler_1),
      new Route(Method.POST, r'users/int:user/int:page', handler_2)
    ]
  );

  await application.run();
}
