import 'dart:io';
import 'dart:convert';

class JsonResponse {
  String content;
  int statusCode;
  Map<String, HeaderValue> headers;

  JsonResponse({
    Object data = const {},
    Map<String, HeaderValue> headers = const {},
    int statusCode = HttpStatus.ok
  }) {
    this.statusCode = statusCode;
    this.headers = {}..addAll(headers);
    this.content = jsonEncode(data);    
  }

  void write(HttpResponse response) {
    response.statusCode = this.statusCode;
    response.headers.add(HttpHeaders.contentTypeHeader, ContentType.json.value);
    
    this.headers.forEach((key, value) {
      response.headers.add(key, value);
    });   

    response.write(this.content);
    response.close();
  }
}
